diff --git a/plugins/impex/tiff/kis_tiff_import.cc b/plugins/impex/tiff/kis_tiff_import.cc
index a5893d365607d42090edd6460bdf7cd03405083e..e6d408e923b8c4bedc806a47e4daa7565b576cff 100644
--- a/plugins/impex/tiff/kis_tiff_import.cc
+++ b/plugins/impex/tiff/kis_tiff_import.cc
@@ -1468,15 +1468,16 @@ KisTIFFImport::readImageFromTiff(KisDocument *m_doc,
 
         // warning: profile is an array of uint32_t's
         if (TIFFIsByteSwapped(image) != 0) {
-            TIFFSwabArrayOfLong(iptc_profile_data, iptc_profile_size);
+            TIFFSwabArrayOfLong(iptc_profile_data,
+                                iptc_profile_size / sizeof(uint32_t));
         }
 
         KisMetaData::IOBackend *iptcIO =
             KisMetadataBackendRegistry::instance()->value("iptc");
 
         // Copy the xmp data into the byte array
-        QByteArray ba(reinterpret_cast<char *>(iptc_profile_data),
-                      static_cast<int>(sizeof(uint32_t) * iptc_profile_size));
+        QByteArray ba(reinterpret_cast<const char *>(iptc_profile_data),
+                      static_cast<int>(iptc_profile_size));
         QBuffer buf(&ba);
         iptcIO->loadFrom(layer->metaData(), &buf);
     }
